--- emacs24-24.3+1.orig/lisp/progmodes/cc-awk.el
+++ emacs24-24.3+1/lisp/progmodes/cc-awk.el
@@ -621,13 +663,13 @@
   (if pos (goto-char pos))
   (forward-line 0)
   (while (and (> (point) (point-min))
-              (eq (char-before (1- (point))) ?\\))
+	      (eq (char-before (1- (point))) ?\\))
     (forward-line -1))
   (point))
 
 (defun c-awk-beyond-logical-line (&optional pos)
 ;; Return the position just beyond the (apparent) current logical line, or the
-;; one containing POS.  This is usually the beginning of the next line which
+;; one containing POS.	This is usually the beginning of the next line which
 ;; doesn't follow an escaped EOL.  At EOB, this will be EOB.
 ;;
 ;; Point is unchanged.
@@ -654,7 +696,7 @@
 (defun c-awk-set-string-regexp-syntax-table-properties (beg end)
 ;; BEG and END bracket a (possibly unterminated) string or regexp.  The
 ;; opening delimiter is after BEG, and the closing delimiter, IF ANY, is AFTER
-;; END.  Set the appropriate syntax-table properties on the delimiters and
+;; END.	 Set the appropriate syntax-table properties on the delimiters and
 ;; contents of this string/regex.
 ;;
 ;; "String" here can also mean a gawk 3.1 "localizable" string which starts
@@ -668,21 +710,21 @@
   (if (eq (char-after beg) ?_) (setq beg (1+ beg)))
 
   ;; First put the properties on the delimiters.
-  (cond ((eq end (point-max))           ; string/regexp terminated by EOB
-         (c-put-char-property beg 'syntax-table '(15))) ; (15) = "string fence"
-        ((/= (char-after beg) (char-after end)) ; missing end delimiter
-         (c-put-char-property beg 'syntax-table '(15))
-         (c-put-char-property end 'syntax-table '(15)))
-        ((eq (char-after beg) ?/)       ; Properly bracketed regexp
-         (c-put-char-property beg 'syntax-table '(7)) ; (7) = "string"
-         (c-put-char-property end 'syntax-table '(7)))
-        (t))                       ; Properly bracketed string: Nothing to do.
+  (cond ((eq end (point-max))		; string/regexp terminated by EOB
+	 (c-put-char-property beg 'syntax-table '(15))) ; (15) = "string fence"
+	((/= (char-after beg) (char-after end)) ; missing end delimiter
+	 (c-put-char-property beg 'syntax-table '(15))
+	 (c-put-char-property end 'syntax-table '(15)))
+	((eq (char-after beg) ?/)	; Properly bracketed regexp
+	 (c-put-char-property beg 'syntax-table '(7)) ; (7) = "string"
+	 (c-put-char-property end 'syntax-table '(7)))
+	(t))			   ; Properly bracketed string: Nothing to do.
   ;; Now change the properties of any escaped "s in the string to punctuation.
   (save-excursion
     (goto-char (1+ beg))
     (or (eobp)
-        (while (search-forward "\"" end t)
-          (c-put-char-property (1- (point)) 'syntax-table '(1))))))
+	(while (search-forward "\"" end t)
+	  (c-put-char-property (1- (point)) 'syntax-table '(1))))))
 
 (defun c-awk-syntax-tablify-string ()
   ;; Point is at the opening " or _" of a string.  Set the syntax-table
@@ -696,12 +738,12 @@
   (c-awk-set-string-regexp-syntax-table-properties
    (match-beginning 0) (match-end 0))
   (cond ((looking-at "\"")
-         (forward-char)
-         t)                             ; In AWK, ("15" / 5) gives 3 ;-)
-        ((looking-at "[\n\r]")          ; Unterminated string with EOL.
-         (forward-char)
-         nil)                           ; / on next line would start a regexp
-        (t nil)))                       ; Unterminated string at EOB
+	 (forward-char)
+	 t)				; In AWK, ("15" / 5) gives 3 ;-)
+	((looking-at "[\n\r]")		; Unterminated string with EOL.
+	 (forward-char)
+	 nil)				; / on next line would start a regexp
+	(t nil)))			; Unterminated string at EOB
 
 (defun c-awk-syntax-tablify-/ (anchor anchor-state-/div)
   ;; Point is at a /.  Determine whether this is a division sign or a regexp
@@ -711,7 +753,7 @@
   ;;
   ;; ANCHOR-STATE-/DIV identifies whether a / at ANCHOR would have been a
   ;; division sign (value t) or a regexp opener (value nil).  The idea is that
-  ;; we analyze the line from ANCHOR up till point to determine what the / at
+  ;; we analyse the line from ANCHOR up till point to determine what the / at
   ;; point is.
   ;;
   ;; The result is what ANCHOR-STATE-/DIV (see above) is where point is left.
@@ -719,11 +761,12 @@
   ;; This function does hidden buffer changes.
   (let ((/point (point)))
     (goto-char anchor)
-    ;; Analyze the line to find out what the / is.
+    ;; Analyse the line to find out what the / is.
     (if (if anchor-state-/div
-            (not (search-forward-regexp c-awk-regexp-sign-re (1+ /point) t))
-          (search-forward-regexp c-awk-div-sign-re (1+ /point) t))
-        ;; A division sign.
+	    (not (search-forward-regexp c-awk-regexp-sign-re (1+ /point) t))
+	  (and (not (search-forward-regexp c-awk-kwd-regexp-sign-re (1+ /point) t))
+	       (search-forward-regexp c-awk-div-sign-re (1+ /point) t)))
+	;; A division sign.
 	(progn (goto-char (1+ /point)) nil)
       ;; A regexp opener
       ;; Jump over the regexp innards, setting the match data.
@@ -731,13 +774,13 @@
       (search-forward-regexp c-awk-regexp-without-end-re)
       (c-awk-set-string-regexp-syntax-table-properties
        (match-beginning 0) (match-end 0))
-      (cond ((looking-at "/")           ; Terminating /
-             (forward-char)
-             t)
-            ((looking-at "[\n\r]")      ; Incomplete regexp terminated by EOL
-             (forward-char)
-             nil)                  ; / on next line would start another regexp
-            (t nil)))))                 ; Unterminated regexp at EOB
+      (cond ((looking-at "/")		; Terminating /
+	     (forward-char)
+	     t)
+	    ((looking-at "[\n\r]")	; Incomplete regexp terminated by EOL
+	     (forward-char)
+	     nil)		   ; / on next line would start another regexp
+	    (t nil)))))			; Unterminated regexp at EOB
 
 (defun c-awk-set-syntax-table-properties (lim)
 ;;     Scan the buffer text between point and LIM, setting (and clearing) the
@@ -747,7 +790,7 @@
 ;; font-lock-syntactic-keywords, and it always returns NIL (to inhibit
 ;; repeated calls from font-lock: See elisp info page "Search-based
 ;; Fontification").  It also gets called, with a bit of glue, from
-;; after-change-functions when font-lock isn't active.  Point is left
+;; after-change-functions when font-lock isn't active.	Point is left
 ;; "undefined" after this function exits.  THE BUFFER SHOULD HAVE BEEN
 ;; WIDENED, AND ANY PRECIOUS MATCH-DATA SAVED BEFORE CALLING THIS ROUTINE.
 ;;
@@ -759,29 +802,37 @@
 ;;    "generic string delimiter" on both the opening " or / and the end of the
 ;;    line where the closing delimiter is missing.
 ;; (iii) "s inside strings/regexps (these will all be escaped "s).  They are
-;;   given the property "punctuation".  This will later allow other routines
+;;   given the property "punctuation".	This will later allow other routines
 ;;   to use the regexp "\\S\"*" to skip over the string innards.
 ;; (iv) Inside a comment, all syntax-table properties are cleared.
 ;;
 ;; This function does hidden buffer changes.
   (let (anchor
 	(anchor-state-/div nil)) ; t means a following / would be a div sign.
-    (c-awk-beginning-of-logical-line) ; ACM 2002/7/21.  This is probably redundant.
+    (c-awk-beginning-of-logical-line) ; ACM 2002/7/21.	This is probably redundant.
     (c-clear-char-properties (point) lim 'syntax-table)
     ;; Once round the next loop for each string, regexp, or div sign
     (while (progn
-             ;; Skip any "harmless" lines before the next tricky one.
-             (if (search-forward-regexp c-awk-harmless-lines+-here-re nil t)
-                 (setq anchor-state-/div nil))
-             (< (point) lim))
+	     ;; Skip any "harmless" lines before the next tricky one.
+	     (if (search-forward-regexp c-awk-harmless-lines+-here-re nil t)
+		 (setq anchor-state-/div nil))
+	     (< (point) lim))
       (setq anchor (point))
       (search-forward-regexp c-awk-harmless-string*-here-re nil t)
-      ;; We are now looking at either a " or a /.
-      ;; Do our thing on the string, regexp or division sign.
+      ;; We are now looking at either a " or a / or a brace/paren/semicolon.
+      ;; Do our thing on the string, regexp or divsion sign or update our state.
       (setq anchor-state-/div
-            (if (looking-at "_?\"")
-                (c-awk-syntax-tablify-string)
-              (c-awk-syntax-tablify-/ anchor anchor-state-/div))))
+	    (cond
+	     ((looking-at "_?\"")
+	      (c-awk-syntax-tablify-string))
+	     ((eq (char-after) ?/)
+	      (c-awk-syntax-tablify-/ anchor anchor-state-/div))
+	     ((memq (char-after) '(?{ ?} ?\( ?\;))
+	      (forward-char)
+	      nil)
+	     (t 			; ?\)
+	      (forward-char)
+	      t))))
     nil))
 
 ;; ACM, 2002/07/21: Thoughts: We need an AWK Mode after-change function to set
@@ -824,14 +875,14 @@
 ;; Don't overlook the possibility of the buffer change being the "recapturing"
 ;; of a previously escaped newline.
 
-;; ACM 2008-02-05:
+;; ACM 2008-02-05: 
 (defun c-awk-extend-and-syntax-tablify-region (beg end old-len)
   ;; Expand the region (BEG END) as needed to (c-new-BEG c-new-END) then put
   ;; `syntax-table' properties on this region.
   ;;
   ;; This function is called from an after-change function, BEG END and
   ;; OLD-LEN being the standard parameters.
-  ;;
+  ;; 
   ;; Point is undefined both before and after this function call, the buffer
   ;; has been widened, and match-data saved.  The return value is ignored.
   ;;
@@ -848,8 +899,8 @@
 
 ;; Awk regexps written with help from Peter Galbraith
 ;; <galbraith@mixing.qc.dfo.ca>.
-;; Take GNU Emacs's 'words out of the following regexp-opts.  They don't work
-;; in XEmacs 21.4.4.  acm 2002/9/19.
+;; Take GNU Emacs's 'words out of the following regexp-opts.  They dont work
+;; in Xemacs 21.4.4.  acm 2002/9/19.
 (defconst awk-font-lock-keywords
   (eval-when-compile
     (list
@@ -870,7 +921,7 @@
      ;; Special file names.  (acm, 2002/7/22)
      ;; The following regexp was created by first evaluating this in GNU Emacs 21.1:
      ;; (regexp-opt '("/dev/stdin" "/dev/stdout" "/dev/stderr" "/dev/fd/n" "/dev/pid"
-     ;;                 "/dev/ppid" "/dev/pgrpid" "/dev/user") 'words)
+     ;;			"/dev/ppid" "/dev/pgrpid" "/dev/user") 'words)
      ;; , removing the "?:" from each "\\(?:" (for backward compatibility with older Emacsen)
      ;; , replacing the "n" in "dev/fd/n" with "[0-9]+"
      ;; , removing the unwanted \\< at the beginning, and finally filling out the
@@ -884,7 +935,7 @@ std\\(err\\|in\\|out\\)\\|user\\)\\)\\>\
        (8 font-lock-variable-name-face t t))
      ;; Do the same (almost) with
      ;; (regexp-opt '("/inet/tcp/lport/rhost/rport" "/inet/udp/lport/rhost/rport"
-     ;;                 "/inet/raw/lport/rhost/rport") 'words)
+     ;;			"/inet/raw/lport/rhost/rport") 'words)
      ;; This cannot be combined with the above pattern, because the match number
      ;; for the (optional) closing \" would then exceed 9.
      '("\\(\"/inet/\\(\\(raw\\|\\(tc\\|ud\\)p\\)/lport/rhost/rport\\)\\)\\>\
@@ -929,7 +980,7 @@ std\\(err\\|in\\|out\\)\\|user\\)\\)\\>\
      ;; Space after \ in what looks like an escaped newline.  2002/5/31
      '("\\\\\\s +$" 0 font-lock-warning-face t)
 
-     ;; Unbalanced string (") or regexp (/) delimiters.  2002/02/16.
+     ;; Unbalanced string (") or regexp (/) delimiters.	 2002/02/16.
      '("\\s|" 0 font-lock-warning-face t nil)
      ;; gawk 3.1 localizable strings ( _"translate me!").  2002/5/21
      '("\\(_\\)\\s|" 1 font-lock-warning-face)
@@ -940,7 +991,7 @@ std\\(err\\|in\\|out\\)\\|user\\)\\)\\>\
 ;; ACM 2002/9/29.  Movement functions, e.g. for C-M-a and C-M-e
 
 ;; The following three regexps differ from those earlier on in cc-awk.el in
-;; that they assume the syntax-table properties have been set.  They are thus
+;; that they assume the syntax-table properties have been set.	They are thus
 ;; not useful for code which sets these properties.
 (defconst c-awk-terminated-regexp-or-string-here-re "\\=\\s\"\\S\"*\\s\"")
 ;; Matches a terminated string/regexp.
@@ -954,8 +1005,8 @@ std\\(err\\|in\\|out\\)\\|user\\)\\)\\>\
 
 (defun c-awk-at-statement-end-p ()
   ;; Point is not inside a comment or string.  Is it AT the end of a
-  ;; statement?  This means immediately after the last non-ws character of the
-  ;; statement.  The caller is responsible for widening the buffer, if
+  ;; statement?	 This means immediately after the last non-ws character of the
+  ;; statement.	 The caller is responsible for widening the buffer, if
   ;; appropriate.
   (and (not (bobp))
        (save-excursion
@@ -968,9 +1019,9 @@ std\\(err\\|in\\|out\\)\\|user\\)\\)\\>\
 			     "[#\n\r]"))))))))
 
 (defun c-awk-beginning-of-defun (&optional arg)
-  "Move backward to the beginning of an AWK \"defun\".  With ARG, do it that
+  "Move backward to the beginning of an AWK \"defun\".	With ARG, do it that
 many times.  Negative arg -N means move forward to Nth following beginning of
-defun.  Returns t unless search stops due to beginning or end of buffer.
+defun.	Returns t unless search stops due to beginning or end of buffer.
 
 By a \"defun\" is meant either a pattern-action pair or a function.  The start
 of a defun is recognized as code starting at column zero which is neither a
@@ -978,31 +1029,31 @@ closing brace nor a comment nor a contin
 in some other modes, having an opening brace at column 0 is neither necessary
 nor helpful.
 
-Note that this function might do hidden buffer changes.  See the
+Note that this function might do hidden buffer changes.	 See the
 comment at the start of cc-engine.el for more info."
   (interactive "p")
   (or arg (setq arg 1))
   (save-match-data
-    (c-save-buffer-state                ; ensures the buffer is writable.
+    (c-save-buffer-state		; ensures the buffer is writable.
      nil
-     (let ((found t))     ; Has the most recent regexp search found b-of-defun?
+     (let ((found t))	  ; Has the most recent regexp search found b-of-defun?
        (if (>= arg 0)
-           ;; Go back one defun each time round the following loop. (For +ve arg)
-           (while (and found (> arg 0) (not (eq (point) (point-min))))
-             ;; Go back one "candidate" each time round the next loop until one
-             ;; is genuinely a beginning-of-defun.
-             (while (and (setq found (search-backward-regexp
-                                      "^[^#} \t\n\r]" (point-min) 'stop-at-limit))
-                         (not (memq (c-awk-get-NL-prop-prev-line) '(?\$ ?\} ?\#)))))
-             (setq arg (1- arg)))
-         ;; The same for a -ve arg.
-         (if (not (eq (point) (point-max))) (forward-char 1))
-         (while (and found (< arg 0) (not (eq (point) (point-max)))) ; The same for -ve arg.
-           (while (and (setq found (search-forward-regexp
-                                    "^[^#} \t\n\r]" (point-max) 'stop-at-limit))
-                       (not (memq (c-awk-get-NL-prop-prev-line) '(?\$ ?\} ?\#)))))
-           (setq arg (1+ arg)))
-         (if found (goto-char (match-beginning 0))))
+	   ;; Go back one defun each time round the following loop. (For +ve arg)
+	   (while (and found (> arg 0) (not (eq (point) (point-min))))
+	     ;; Go back one "candidate" each time round the next loop until one
+	     ;; is genuinely a beginning-of-defun.
+	     (while (and (setq found (search-backward-regexp
+				      "^[^#} \t\n\r]" (point-min) 'stop-at-limit))
+			 (not (memq (c-awk-get-NL-prop-prev-line) '(?\$ ?\} ?\#)))))
+	     (setq arg (1- arg)))
+	 ;; The same for a -ve arg.
+	 (if (not (eq (point) (point-max))) (forward-char 1))
+	 (while (and found (< arg 0) (not (eq (point) (point-max)))) ; The same for -ve arg.
+	   (while (and (setq found (search-forward-regexp
+				    "^[^#} \t\n\r]" (point-max) 'stop-at-limit))
+		       (not (memq (c-awk-get-NL-prop-prev-line) '(?\$ ?\} ?\#)))))
+	   (setq arg (1+ arg)))
+	 (if found (goto-char (match-beginning 0))))
        (eq arg 0)))))
 
 (defun c-awk-forward-awk-pattern ()
@@ -1015,18 +1066,18 @@ comment at the start of cc-engine.el for
   ;; This function might do hidden buffer changes.
   (while
       (progn
-        (search-forward-regexp c-awk-harmless-pattern-characters*)
-        (if (looking-at "#") (end-of-line))
-        (cond
-         ((eobp) nil)
-         ((looking-at "[{;]") nil)  ; We've finished!
-         ((eolp)
-          (if (c-awk-cur-line-incomplete-p)
-              (forward-line)            ; returns non-nil
-            nil))
-         ((search-forward-regexp c-awk-terminated-regexp-or-string-here-re nil t))
-         ((search-forward-regexp c-awk-unterminated-regexp-or-string-here-re nil t))
-         ((looking-at "/") (forward-char) t))))) ; division sign.
+	(search-forward-regexp c-awk-harmless-pattern-characters*)
+	(if (looking-at "#") (end-of-line))
+	(cond
+	 ((eobp) nil)
+	 ((looking-at "[{;]") nil)  ; We've finished!
+	 ((eolp)
+	  (if (c-awk-cur-line-incomplete-p)
+	      (forward-line)		; returns non-nil
+	    nil))
+	 ((search-forward-regexp c-awk-terminated-regexp-or-string-here-re nil t))
+	 ((search-forward-regexp c-awk-unterminated-regexp-or-string-here-re nil t))
+	 ((looking-at "/") (forward-char) t))))) ; division sign.
 
 (defun c-awk-end-of-defun1 ()
   ;; point is at the start of a "defun".  Move to its end.  Return end position.
@@ -1056,7 +1107,7 @@ An end of a defun occurs right after the
 opening brace at its start, or immediately after the AWK pattern when there is
 no explicit action; see function `c-awk-beginning-of-defun'.
 
-Note that this function might do hidden buffer changes.  See the
+Note that this function might do hidden buffer changes.	 See the
 comment at the start of cc-engine.el for more info."
   (interactive "p")
   (or arg (setq arg 1))
@@ -1067,33 +1118,34 @@ comment at the start of cc-engine.el for
        ;; Strategy: (For +ve ARG): If we're not already at a beginning-of-defun,
        ;; move backwards to one.
        ;; Repeat [(i) move forward to end-of-current-defun (see below);
-       ;;         (ii) If this isn't it, move forward to beginning-of-defun].
+       ;;	  (ii) If this isn't it, move forward to beginning-of-defun].
        ;; We start counting ARG only when step (i) has passed the original point.
        (when (> arg 0)
-         ;; Try to move back to a beginning-of-defun, if not already at one.
-         (if (not (c-awk-beginning-of-defun-p))
-             (when (not (c-awk-beginning-of-defun 1)) ; No bo-defun before point.
-               (goto-char start-point)
-               (c-awk-beginning-of-defun -1))) ; if this fails, we're at EOB, tough!
-         ;; Now count forward, one defun at a time
-         (while (and (not (eobp))
-                     (c-awk-end-of-defun1)
-                     (if (> (point) start-point) (setq arg (1- arg)) t)
-                     (> arg 0)
-                     (c-awk-beginning-of-defun -1))))
+	 ;; Try to move back to a beginning-of-defun, if not already at one.
+	 (if (not (c-awk-beginning-of-defun-p))
+	     (when (not (c-awk-beginning-of-defun 1)) ; No bo-defun before point.
+	       (goto-char start-point)
+	       (c-awk-beginning-of-defun -1))) ; if this fails, we're at EOB, tough!
+	 ;; Now count forward, one defun at a time
+	 (while (and (not (eobp))
+		     (c-awk-end-of-defun1)
+		     (if (> (point) start-point) (setq arg (1- arg)) t)
+		     (> arg 0)
+		     (c-awk-beginning-of-defun -1))))
 
        (when (< arg 0)
-         (setq end-point start-point)
-         (while (and (not (bobp))
-                     (c-awk-beginning-of-defun 1)
-                     (if (< (setq end-point (if (bobp) (point)
-                                              (save-excursion (c-awk-end-of-defun1))))
-                            start-point)
-                         (setq arg (1+ arg)) t)
-                     (< arg 0)))
-         (goto-char (min start-point end-point)))))))
+	 (setq end-point start-point)
+	 (while (and (not (bobp))
+		     (c-awk-beginning-of-defun 1)
+		     (if (< (setq end-point (if (bobp) (point)
+					      (save-excursion (c-awk-end-of-defun1))))
+			    start-point)
+			 (setq arg (1+ arg)) t)
+		     (< arg 0)))
+	 (goto-char (min start-point end-point)))))))
 
 
 (cc-provide 'cc-awk)			; Changed from 'awk-mode, ACM 2002/5/21
 
+;;; arch-tag: c4836289-3aa4-4a59-9934-9ccc2bacccf3
 ;;; awk-mode.el ends here
--- emacs24-24.3+1.orig/lisp/progmodes/cc-bytecomp.el
+++ emacs24-24.3+1/lisp/progmodes/cc-bytecomp.el
@@ -1,19 +1,20 @@
 ;;; cc-bytecomp.el --- compile time setup for proper compilation
 
-;; Copyright (C) 2000-2013 Free Software Foundation, Inc.
+;; Copyright (C) 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007,
+;;   2008, 2009, 2010, 2011  Free Software Foundation, Inc.
 
 ;; Author:     Martin Stjernholm
 ;; Maintainer: bug-cc-mode@gnu.org
 ;; Created:    15-Jul-2000
-;; Keywords:   c languages
-;; Package:    cc-mode
+;; Version:    See cc-mode.el
+;; Keywords:   c languages oop
 
 ;; This file is part of GNU Emacs.
 
-;; GNU Emacs is free software: you can redistribute it and/or modify
+;; GNU Emacs is free software; you can redistribute it and/or modify
 ;; it under the terms of the GNU General Public License as published by
-;; the Free Software Foundation, either version 3 of the License, or
-;; (at your option) any later version.
+;; the Free Software Foundation; either version 3, or (at your option)
+;; any later version.
 
 ;; GNU Emacs is distributed in the hope that it will be useful,
 ;; but WITHOUT ANY WARRANTY; without even the implied warranty of
@@ -21,7 +22,8 @@
 ;; GNU General Public License for more details.
 
 ;; You should have received a copy of the GNU General Public License
-;; along with GNU Emacs.  If not, see <http://www.gnu.org/licenses/>.
+;; along with this program; see the file COPYING.  If not, see
+;; <http://www.gnu.org/licenses/>.
 
 ;;; Commentary:
 
@@ -78,6 +80,15 @@
 (defvar cc-bytecomp-original-functions nil)
 (defvar cc-bytecomp-original-properties nil)
 (defvar cc-bytecomp-loaded-files nil)
+(defvar cc-bytecomp-push-vars nil
+  "A stack ((VAR GLOBAL-VAL SETQD-VAL) ...)")
+
+(setq cc-bytecomp-unbound-variables nil)
+(setq cc-bytecomp-original-functions nil)
+(setq cc-bytecomp-original-properties nil)
+(setq cc-bytecomp-loaded-files nil)
+(setq cc-bytecomp-push-vars nil)
+
 (defvar cc-bytecomp-environment-set nil)
 
 (defmacro cc-bytecomp-debug-msg (&rest args)
@@ -131,6 +142,15 @@ perhaps a `cc-bytecomp-restore-environme
 	     "cc-bytecomp-setup-environment: Bound property %s for %s to %s"
 	     prop sym tempdef))
 	  (setq p (cdr p)))
+	(setq p (reverse cc-bytecomp-push-vars))
+	(while p
+	  (let ((var (caar p))
+		(setqd-val (cadr (cdar p))))
+	    (set var setqd-val)
+	    (cc-bytecomp-debug-msg
+	     "cc-bytecomp-setup-environment: Set variable %s to %s"
+	     var setqd-val))
+	  (setq p (cdr p)))
 	(setq cc-bytecomp-environment-set t)
 	(cc-bytecomp-debug-msg
 	 "cc-bytecomp-setup-environment: Done"))))
@@ -196,6 +216,18 @@ perhaps a `cc-bytecomp-restore-environme
 	       "cc-bytecomp-restore-environment: Not restoring property %s for %s"
 	       prop sym)))
 	  (setq p (cdr p)))
+	(setq p cc-bytecomp-push-vars)
+	(while p
+	  (let ((var (caar p))
+		(global-val (cadr (car p)))
+		)
+	    (if (eq global-val 'cc-bytecomp-unbound)
+		(makunbound var)
+	      (set var global-val))
+	    (cc-bytecomp-debug-msg
+	     "cc-bytecomp-restore-environment: Restored variable %s to %s"
+	     var global-val))
+	  (setq p (cdr p)))
 	(setq cc-bytecomp-environment-set nil)
 	(cc-bytecomp-debug-msg
 	 "cc-bytecomp-restore-environment: Done"))))
@@ -338,6 +370,30 @@ at compile time, e.g. for macros and inl
 	     (cc-bytecomp-debug-msg
 	      "cc-bytecomp-defun: Covered function %s" ',fun))))))
 
+(put 'cc-bytecomp-defmacro 'lisp-indent-function 'defun)
+(defmacro cc-bytecomp-defmacro (fun &rest temp-macro)
+  "Bind the symbol as a macro during compilation (and evaluation) of the
+file.  Don't use outside `eval-when-compile'."
+  `(let ((orig-fun (assq ',fun cc-bytecomp-original-functions)))
+     (if (not orig-fun)
+	 (setq orig-fun
+	       (list ',fun
+		     nil
+		     (if (fboundp ',fun)
+			 (progn
+			   (cc-bytecomp-debug-msg
+			    "cc-bytecomp-defmacro: Saving %s" ',fun)
+			   (symbol-function ',fun))
+		       (cc-bytecomp-debug-msg
+			"cc-bytecomp-defmacro: Saving %s as unbound" ',fun)
+		       'unbound))
+	       cc-bytecomp-original-functions
+	       (cons orig-fun cc-bytecomp-original-functions)))
+     (defmacro ,fun ,@temp-macro)
+     (cc-bytecomp-debug-msg
+      "cc-bytecomp-defmacro: Bound macro %s" ',fun)
+     (setcar (cdr orig-fun) (symbol-function ',fun))))
+
 (defmacro cc-bytecomp-put (symbol propname value)
   "Set a property on a symbol during compilation (and evaluation) of
 the file.  Don't use outside `eval-when-compile'."
@@ -356,6 +412,26 @@ the file.  Don't use outside `eval-when-
       "cc-bytecomp-put: Bound property %s for %s to %s"
       ,propname ,symbol ,value)))
 
+(defmacro cc-bytecomp-push (symbol value)
+  "Set SYMBOL to VALUE during compilation (and evaluation) of the file.
+Don't use within `eval-when-compile'."
+  `(eval-when-compile
+     (cc-bytecomp-debug-msg
+      "cc-bytecomp-push: symbol is %s, value is %s"
+      ',symbol ,value)
+     (setq cc-bytecomp-set-vars
+	   (cons (list ',symbol
+		       (if (boundp ',symbol)
+			   ,symbol
+			 'cc-bytecomp-unbound)
+		       ,value)
+		 cc-bytecomp-push-vars))
+     (cc-bytecomp-debug-msg
+      "cc-bytecomp-push: set %s to %s" ',symbol ,value)
+     (set ',symbol ,value)
+     (cc-bytecomp-debug-msg
+      "cc-bytecomp-push: cc-bytecomp-push-vars is %s" cc-bytecomp-push-vars)))
+
 (defmacro cc-bytecomp-obsolete-var (symbol)
   "Suppress warnings that the given symbol is an obsolete variable.
 Don't use within `eval-when-compile'."
@@ -369,19 +445,24 @@ Don't use within `eval-when-compile'."
 (defun cc-bytecomp-ignore-obsolete (form)
   ;; Wraps a call to `byte-compile-obsolete' that suppresses the warning.
   (let ((byte-compile-warnings byte-compile-warnings))
-    (byte-compile-disable-warning 'obsolete)
-    (byte-compile-obsolete form)))
+    (if (fboundp 'byte-compile-disable-warning) ; Emacs 23+
+	(byte-compile-disable-warning 'obsolete)
+      (delq 'obsolete (append byte-compile-warnings nil)))
+    (if (fboundp 'byte-compile-obsolete) ; purely to suppress a warnin.
+	(byte-compile-obsolete form))))
 
 (defmacro cc-bytecomp-obsolete-fun (symbol)
   "Suppress warnings that the given symbol is an obsolete function.
 Don't use within `eval-when-compile'."
   `(eval-when-compile
-     (if (eq (get ',symbol 'byte-compile) 'byte-compile-obsolete)
-	 (cc-bytecomp-put ',symbol 'byte-compile
-			  'cc-bytecomp-ignore-obsolete)
-       ;; This avoids a superfluous compiler warning
-       ;; about calling `get' for effect.
-       t)))
+     ,(if (fboundp 'byte-compile-obsolete)
+	  `(if (eq (get ',symbol 'byte-compile) 'byte-compile-obsolete)
+	       (cc-bytecomp-put ',symbol 'byte-compile
+				'cc-bytecomp-ignore-obsolete)
+	     ;; This avoids a superfluous compiler warning
+	     ;; about calling `get' for effect.
+	     t)
+	`(cc-bytecomp-push byte-compile-not-obsolete-funcs '(,symbol)))))
 
 (defmacro cc-bytecomp-boundp (symbol)
   "Return non-nil if the given symbol is bound as a variable outside
@@ -409,4 +490,5 @@ exclude any functions that have been bou
 
 (provide 'cc-bytecomp)
 
+;;; arch-tag: 2d71b3ad-57b0-4b13-abd3-ab836e08f975
 ;;; cc-bytecomp.el ends here
